diff -urN microwindows-0.91/src/Configs/config_target microwindows-0.91.g100/src/Configs/config_target
--- microwindows-0.91/src/Configs/config_target	1970-01-01 01:00:00.000000000 +0100
+++ microwindows-0.91.g100/src/Configs/config_target	2007-06-16 17:04:30.000000000 +0200
@@ -0,0 +1,400 @@
+####################################################################
+# Microwindows and Nano-X configuration file
+#
+# This package can be configured to run on Linux (MIPS, ARM, POWERPC or x86)
+# UNIX, ELKS, DJGPP, or RTEMS.
+# On Linux, we've got drivers for Linux 2.x framebuffers, X11, or,
+# svgalib for VGA hardware.
+# In addition, a gpm or direct serial mouse driver can be configured.
+# On ELKS, the bios screen driver and serial mouse driver are always used.
+#
+# Either Microwindows and/or Nano-X can be built.
+# Microwindows and Nano-X have several demos.
+#
+# For MSDOS makes, see mcmwin.mak and mcnanox.mak
+####################################################################
+
+####################################################################
+#
+# build target platform
+#
+# Valid ARCH values are:
+#
+# LINUX-NATIVE
+# LINUX-TCC
+# LINUX-ARM
+# LINUX-MIPS
+# LINUX-POWERPC (BIGENDIAN=Y)
+# LINUX-SPARC (BIGENDIAN=Y)
+# LINUX-SH
+# FREEBSD-X86
+# SOLARIS (BIGENDIAN=Y)
+# TRIMEDIA
+# RTEMS
+# DJGPP
+# ELKS
+#
+# note: ELKS can't build client/server nano-X, nor widget lib
+#
+####################################################################
+ARCH                     = LINUX-MIPS
+BIGENDIAN                = N
+ARMTOOLSPREFIX           = arm-linux-
+MIPSTOOLSPREFIX          = mipsel-linux-
+POWERPCTOOLSPREFIX       = powerpc-linux-
+SHTOOLSPREFIX            = sh-linux-gnu
+RTEMSTOOLSPREFIX         = i386-rtemself-
+
+#REM: only valid for mips
+DISSABLE-SOFT-FLOAT      = Y
+
+####################################################################
+#
+# Compiling options
+#
+####################################################################
+OPTIMIZE                 = Y
+DEBUG                    = N
+VERBOSE                  = N
+THREADSAFE               = N
+GPROF                    = N
+
+####################################################################
+#
+# Libraries to build: microwin, nano-X, nanowidget, object frameworks
+#
+####################################################################
+MICROWIN                 = N
+NANOX                    = Y
+SHAREDLIBS               = N
+OBJFRAMEWORK             = N
+
+
+####################################################################
+#
+# Demos to build
+#
+####################################################################
+MICROWINDEMO             = N
+NANOXDEMO                = N
+
+####################################################################
+#
+# Applications to build
+#
+####################################################################
+NANOWM                   = Y
+
+####################################################################
+# REM: TCP_IP support for Nano-X client/server protocol vonnection via
+# REM: LAN or Internet
+####################################################################
+
+HAVE_TCP_IP_SUPPORT = N
+
+####################################################################
+# Transparent color support
+#
+####################################################################
+
+HAVE_TRANS_COLOR_SUPPORT = Y
+
+####################################################################
+#
+# The pixeltype of the native hardware or underlying graphics library.
+# This definition defines the PIXELVAL to be 32, 16 or 8 bits wide.
+# If using Linux framebuffer, set to MWPF_TRUECOLOR0888, and use fbset.
+# It also enables GdArea/GrArea for this particular pixel packing format.
+#
+# define MWPF_PALETTE       /* pixel is packed 8 bits 1, 4 or 8 pal index*/
+# define MWPF_TRUECOLOR8888 /* pixel is packed 32 bits 8/8/8/8 truecolor w/alpha*/
+# define MWPF_TRUECOLOR0888 /* pixel is packed 32 bits 8/8/8 truecolor*/
+# define MWPF_TRUECOLOR888  /* pixel is packed 24 bits 8/8/8 truecolor*/
+# define MWPF_TRUECOLOR565  /* pixel is packed 16 bits 5/6/5 truecolor*/
+# define MWPF_TRUECOLOR555  /* pixel is packed 16 bits 5/5/5 truecolor*/
+# define MWPF_TRUECOLOR332  /* pixel is packed 8 bits 3/3/2 truecolor*/
+#
+####################################################################
+SCREEN_PIXTYPE           = MWPF_TRUECOLOR565
+
+####################################################################
+#
+# NanoX: Put Y to the following line to link the nano-X application
+# with the server.  This is required for ELKS, if no network is present,
+# or for speed or debugging.  This affects the nano-X server only.
+#
+####################################################################
+LINK_APP_INTO_SERVER     = Y
+
+####################################################################
+# Shared memory support for Nano-X client/server protocol speedup
+####################################################################
+HAVE_SHAREDMEM_SUPPORT   = N
+
+####################################################################
+#
+# File I/O support
+# Supporting either below drags in libc stdio, which may not be wanted
+#
+####################################################################
+HAVE_FILEIO              = Y
+
+####################################################################
+# BMP, GIF reading support
+####################################################################
+HAVE_BMP_SUPPORT         = Y
+HAVE_GIF_SUPPORT         = Y
+HAVE_PNM_SUPPORT         = N
+HAVE_XPM_SUPPORT         = N
+
+####################################################################
+# JPEG support through libjpeg, see README.txt in contrib/jpeg
+####################################################################
+HAVE_JPEG_SUPPORT        = N
+INCJPEG                  = .
+LIBJPEG                  = /usr/lib/libjpeg.a
+
+####################################################################
+# PNG support via libpng and libz
+####################################################################
+HAVE_PNG_SUPPORT         = N
+INCPNG                   = /usr/include
+LIBPNG                   = /usr/lib/libpng.a
+LIBZ                     = /usr/lib/libz.a
+
+####################################################################
+# TIFF support through libtiff
+####################################################################
+HAVE_TIFF_SUPPORT        = N
+INCTIFF                  = /usr/include
+LIBTIFF                  = /usr/lib/libtiff.a
+
+####################################################################
+# native .fnt loadable font support
+####################################################################
+HAVE_FNT_SUPPORT         = N
+HAVE_FNTGZ_SUPPORT       = N
+FNT_FONT_DIR             = "fonts/bdf"
+
+####################################################################
+# T1 adobe type1 font support thru t1lib
+####################################################################
+HAVE_T1LIB_SUPPORT       = N
+INCT1LIB                 = /usr/include
+LIBT1LIB                 = /usr/lib/libt1.a
+
+####################################################################
+# TrueType font support thru FreeType 1.x
+####################################################################
+HAVE_FREETYPE_SUPPORT    = N
+INCFTLIB                 = /usr/include
+LIBFTLIB                 = /usr/lib/libttf.so
+FREETYPE_FONT_DIR        = "fonts/truetype"
+
+####################################################################
+# Support for many kinds of font thru FreeType 2.x
+# Must also set FREETYPE_FONT_DIR in the Freetype 1.x section
+####################################################################
+HAVE_FREETYPE_2_SUPPORT  = N
+INCFT2LIB                = /usr/include
+LIBFT2LIB                = /usr/lib/libfreetype.a
+
+####################################################################
+# PCF font support 
+# Selecting HAVE_PCFGZ_SUPPORT will allow you to directly read
+# .pcf.gz files, but it will add libz to the size of the server
+####################################################################
+HAVE_PCF_SUPPORT         = Y
+HAVE_PCFGZ_SUPPORT       = N
+PCF_FONT_DIR             = "fonts/pcf"
+
+####################################################################
+# Chinese Han Zi Ku loadable font support
+####################################################################
+HAVE_HZK_SUPPORT         = N
+HZK_FONT_DIR             = "fonts/chinese"
+
+####################################################################
+# Chinese BIG5 compiled in font support (big5font.c)
+####################################################################
+HAVE_BIG5_SUPPORT        = N
+
+####################################################################
+# Chinese GB2312 compiled in font support (gb2312font.c)
+####################################################################
+HAVE_GB2312_SUPPORT      = N
+
+####################################################################
+# Japanese JISX0213 compiled in font support (jisx0213-12x12.c)
+####################################################################
+HAVE_JISX0213_SUPPORT    = N
+
+####################################################################
+# Korean HANGUL font support (jo16x16.c)
+####################################################################
+HAVE_KSC5601_SUPPORT     = N
+
+####################################################################
+# Japanese EUC-JP support using loadable MGL font
+####################################################################
+HAVE_EUCJP_SUPPORT       = N
+EUCJP_FONT_DIR           = "fonts/japanese"
+
+####################################################################
+# Generate screen driver interface only with no fonts or clipping
+####################################################################
+NOFONTSORCLIPPING        = N
+
+####################################################################
+#
+# Window move algorithms for Microwindows
+# Change for tradeoff between cpu speed and looks
+# ERASEMOVE repaints only backgrounds while window dragging, quicker.
+# Otherwise an XOR redraw is used for window moves only after button up,
+# quickest (should set for ELKS)
+# UPDATEREGIONS paints in update clipping region only for better look and feel
+#
+####################################################################
+ERASEMOVE                = Y
+UPDATEREGIONS            = Y
+
+####################################################################
+#
+# Link with Gray Palette (valid only for 4bpp modes)
+#
+####################################################################
+GRAYPALETTE              = N
+
+####################################################################
+#
+# If the platform is running UNIX, Linux or RTEMS...
+#
+####################################################################
+ifneq ($(ARCH), ELKS)
+
+# X Window screen, mouse and kbd drivers
+X11                      = N
+
+ifeq ($(X11), Y)
+# startup screen width, height, (depth for palette mode only)
+SCREEN_WIDTH             = 640
+SCREEN_HEIGHT            = 480
+SCREEN_DEPTH             = 4
+
+# You may want to turn this on for XFree86 4.x or if your backing store
+# isn't functioning properly
+USE_EXPOSURE		 = Y
+
+else
+
+# framebuffer screen driver (linear and/or vga 4 planes)
+# set VTSWITCH to include virtual terminal switch code
+# set FBREVERSE to reverse bit orders in 1,2,4 bpp
+# set FBVGA=N for all systems without VGA hardware (for MIPS must=N)
+FRAMEBUFFER              = Y
+FBVGA                    = N
+VTSWITCH                 = Y
+FBREVERSE                = N
+
+# set HAVETEXTMODE=Y for systems that can switch between text & graphics.
+# On a graphics-only embedded system, such as Osprey and Embedded
+# Planet boards, set HAVETEXTMODE=N
+HAVETEXTMODE             = Y
+
+# svgalib screen driver
+VGALIB                   = N
+
+# direct VGA hardware access screen driver
+HWVGA                    = N
+
+####################################################################
+# Mouse drivers
+# GPMMOUSE	gpm mouse
+# SERMOUSE	serial Microsoft, PC, Logitech, PS/2 mice (/dev/psaux)
+# SUNMOUSE	Sun Workstation mouse (/dev/sunmouse)
+# NOMOUSE	no mouse driver
+#
+# Touchscreen drivers
+# IPAQMOUSE	Compaq iPAQ, Intel Assabet (/dev/h3600_tsraw)
+# ZAURUSMOUSE	Sharp Zaurus (/dev/sharp_ts)
+# TUXMOUSE	TuxScreen (/dev/ucb1x00-ts)
+# ADSMOUSE	Applied Data Systems GC+ (/dev/ts)
+# ADS7846MOUSE	        ADS7846 chip, PSI OMAP Innovator (/dev/innnovator_ts)
+# EPMOUSE	Embedded Planet (/dev/tpanel)
+# VHMOUSE	Vtech Helio (/dev/tpanel)
+# MTMOUSE	MicroTouch serial (/dev/ttyS1)
+# PSIONMOUSE	Psion 5 (/dev/touch_psion)
+# YOPYMOUSE	Yopy (/dev/yopy-ts)
+# HARRIERMOUSE	NEC Harrier (/dev/tpanel)
+####################################################################
+GPMMOUSE                 = N
+SERMOUSE                 = N
+SUNMOUSE                 = N
+NOMOUSE                  = N
+IPAQMOUSE                = N
+ZAURUSMOUSE              = N
+TUXMOUSE                 = N
+ADSMOUSE                 = N
+ADS7846MOUSE             = N
+EPMOUSE                  = Y
+VHMOUSE                  = N
+MTMOUSE                  = N
+PSIONMOUSE               = N
+YOPYMOUSE                = N
+HARRIERMOUSE             = N
+
+# keyboard or null kbd driver
+TTYKBD                   = N
+SCANKBD                  = Y
+PIPEKBD                  = N
+IPAQKBD                  = N
+LIRCKBD                  = N
+NOKBD                    = N
+
+#REM:BEGIN  simply comment this line(s) if default device is desired
+KEYBOARDDEV              = "/dev/vc/0"
+MOUSEDEV                 = "/dev/misc/tpanel"
+#REM:END
+endif
+
+####################################################################
+# Screen driver specific configuration
+# SA1100_LCD_LTLEND 4bpp driver with arm SA1100 LCD controller
+# INVERT4BPP 4bpp inverted pixel driver for VTech Helio
+####################################################################
+SA1100_LCD_LTLEND        = N
+INVERT4BPP               = N
+
+####################################################################
+#
+# If the platform is a RTEMS box ....
+#
+####################################################################
+ifeq ($(ARCH), RTEMS)
+
+# Location & BSP information of the RTEMS build
+RTEMS_BUILD              = /tools/build-i386-elf-rtems
+RTEMS_BSP                = pc386
+LINK_APP_INTO_SERVER     = Y
+
+endif
+
+endif
+
+####################################################################
+#
+# If the platform is an ELKS box ...
+#
+####################################################################
+ifeq ($(ARCH), ELKS)
+
+# Higher speed asm driver, c driver of hercules screen driver
+ASMVGADRIVER             = Y
+CVGADRIVER               = N
+HERCDRIVER               = N
+DBGDRIVER                = N
+
+# Mouse support
+SERMOUSE                 = Y
+
+endif
diff -urN microwindows-0.91/src/demo microwindows-0.91.g100/src/demo
--- microwindows-0.91/src/demo	1970-01-01 01:00:00.000000000 +0100
+++ microwindows-0.91.g100/src/demo	2006-10-12 18:23:50.000000000 +0200
@@ -0,0 +1,5 @@
+
+# win32 applications, press <BREAK> key to exit
+bin/mdemo
+#bin/mine	# minefield
+#bin/malpha	# alpha blending
diff -urN microwindows-0.91/src/demos/nanox/Makefile microwindows-0.91.g100/src/demos/nanox/Makefile
--- microwindows-0.91/src/demos/nanox/Makefile	2007-06-17 21:56:35.000000000 +0200
+++ microwindows-0.91.g100/src/demos/nanox/Makefile	2007-06-17 21:44:04.000000000 +0200
@@ -69,7 +69,7 @@
 	$(MW_DIR_BIN)/convpbm \
 	$(MW_DIR_BIN)/nsaver \
 	$(MW_DIR_BIN)/nxcal \
-	$(MW_DIR_BIN)/grabdemo
+	$(MW_DIR_BIN)/grabdemo 
 
 ifneq ($(ARCH),CYGWIN)
 TARGETS += \
@@ -81,8 +81,12 @@
 	$(MW_DIR_BIN)/nxview \
 	$(MW_DIR_BIN)/slider \
 	$(MW_DIR_BIN)/tsdemo \
-	$(MW_DIR_BIN)/tux
-
+	$(MW_DIR_BIN)/tux \
+	$(MW_DIR_BIN)/tux2 \
+	$(MW_DIR_BIN)/nxview2
+#REM: tux2 nxview2
+	       
+	
 # Require MW_FEATURE_TIMERS support:
 TARGETS += \
 	$(MW_DIR_BIN)/nxmag \
@@ -107,6 +111,7 @@
 		$(MW_DIR_SRC)/demos/nanox/world.map \
 		$(MW_DIR_SRC)/demos/nanox/launcher.cnf \
 		$(MW_DIR_SRC)/demos/nanox/tux.gif \
+		$(MW_DIR_SRC)/demos/nanox/tux2.gif \
 		$(MW_DIR_SRC)/demos/nanox/slidebmp.bmp \
 		$(MW_DIR_SRC)/demos/nanox/uponface.ppm \
 		$(MW_DIR_SRC)/demos/nanox/mwlogo.ppm \
@@ -115,6 +120,7 @@
 		$(MW_DIR_SRC)/demos/nanox/ftdemo.txt\
 		$(MW_DIR_BIN)
 
+#		REM: tux2.gif added
 #		$(MW_DIR_SRC)/demos/nanox/transtest.gif
 #		$(MW_DIR_SRC)/demos/nanox/alphatest.png
 
diff -urN microwindows-0.91/src/demos/nanox/ntetris.c microwindows-0.91.g100/src/demos/nanox/ntetris.c
--- microwindows-0.91/src/demos/nanox/ntetris.c	2007-06-17 21:56:35.000000000 +0200
+++ microwindows-0.91.g100/src/demos/nanox/ntetris.c	2006-10-12 18:23:42.000000000 +0200
@@ -242,7 +242,11 @@
 			if(forcedraw || (state->blocks[0][y][x] !=
 						state->blocks[1][y][x])) {
 				state->blocks[1][y][x] = state->blocks[0][y][x];
-				GrSetGCForeground(state->wellgc,
+//*REM*/
+/*REM*/                         if(!state->blocks[0][y][x])
+/*REM*/                           GrSetGCForeground(state->wellgc,NEXT_SHAPE_WINDOW_BACKGROUND_COLOUR);
+/*REM*/                         else
+ 				  GrSetGCForeground(state->wellgc,
 							state->blocks[0][y][x]);
 				GrFillRect(state->well_window, state->wellgc,
 					(BLOCK_SIZE * x),
diff -urN microwindows-0.91/src/demos/nanox/nxview2.c microwindows-0.91.g100/src/demos/nanox/nxview2.c
--- microwindows-0.91/src/demos/nanox/nxview2.c	1970-01-01 01:00:00.000000000 +0100
+++ microwindows-0.91.g100/src/demos/nanox/nxview2.c	2007-05-30 23:32:46.000000000 +0200
@@ -0,0 +1,81 @@
+/*
+ * Copyright (c) 2000, 2001 Greg Haerr <greg@censoft.com>
+ *
+ * nxview - Nano-X image viewer
+ *
+ * Autorecognizes and displays BMP, GIF, JPEG, PNG and XPM files
+ */
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#define MWINCLUDECOLORS
+#include "nano-X.h"
+
+int
+main(int argc,char **argv)
+{
+	GR_IMAGE_ID	image_id;
+	GR_WINDOW_ID	window_id;
+	GR_GC_ID	gc_id;
+	GR_SIZE		w = -1;
+	GR_SIZE		h = -1;
+	GR_EVENT	event;
+	GR_SCREEN_INFO	sinfo;
+	GR_IMAGE_INFO	info;
+	char		title[256];
+
+	if (argc < 2) {
+		printf("Usage: nxview <image file> [stretch]\n");
+		exit(1);
+	}
+
+	if (GrOpen() < 0) {
+		fprintf(stderr, "cannot open graphics\n");
+		exit(1);
+	}
+	
+	if (!(image_id = GrLoadImageFromFile(argv[1], 0))) {
+		fprintf(stderr, "Can't load image file: %s\n", argv[1]);
+		exit(1);
+	}
+
+	if(argc > 2) {
+		/* stretch to half screen size*/
+		GrGetScreenInfo(&sinfo);
+		w = sinfo.cols/2;
+		h = sinfo.rows/2;
+	} else {
+		GrGetImageInfo(image_id, &info);
+		w = info.width;
+		h = info.height;
+	}
+
+	sprintf(title, "nxview %s", argv[1]);
+	window_id = GrNewWindowEx(GR_WM_PROPS_APPWINDOW, title,
+				  GR_ROOT_WINDOW_ID, 0, 0, w, h, /*BLACK*/GR_ARGB(0,0,0,0));
+
+	GrSelectEvents(window_id,
+		GR_EVENT_MASK_CLOSE_REQ|GR_EVENT_MASK_EXPOSURE);
+
+	GrMapWindow(window_id);
+
+	gc_id = GrNewGC();
+
+	while (1) {
+		GrGetNextEvent(&event);
+		switch(event.type) {
+		case GR_EVENT_TYPE_CLOSE_REQ:
+			GrDestroyWindow(window_id);
+			GrDestroyGC(gc_id);
+			GrFreeImage(image_id);
+			GrClose();
+			exit(0);
+			/* no return*/
+		case GR_EVENT_TYPE_EXPOSURE:
+			GrDrawImageToFit(window_id, gc_id, 0,0, w,h, image_id);
+			break;
+		}
+	}
+
+	return 0;
+}
diff -urN microwindows-0.91/src/demos/nanox/tux2.c microwindows-0.91.g100/src/demos/nanox/tux2.c
--- microwindows-0.91/src/demos/nanox/tux2.c	1970-01-01 01:00:00.000000000 +0100
+++ microwindows-0.91.g100/src/demos/nanox/tux2.c	2007-03-04 20:06:22.000000000 +0100
@@ -0,0 +1,153 @@
+/*
+ * tux - demonstrate shaped window frames for Nano-X
+ */
+/* 
+ * The contents of this file are subject to the Mozilla Public License
+ * Version 1.1 (the "License"); you may not use this file except in
+ * compliance with the License. You may obtain a copy of the License at
+ * http://www.mozilla.org/MPL/
+ * 
+ * Software distributed under the License is distributed on an "AS IS"
+ * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
+ * License for the specific language governing rights and limitations
+ * under the License.
+ * 
+ * The Original Code is Nano-X Tux.
+ * 
+ * The Initial Developer of the Original Code is Alex Holden.
+ * Portions created by Alex Holden are Copyright (C) 2002
+ * Alex Holden <alex@alexholden.net>. All Rights Reserved.
+ * 
+ * Contributor(s):
+ * 
+ * Alternatively, the contents of this file may be used under the terms
+ * of the GNU General Public license (the  "[GNU] License"), in which case the
+ * provisions of [GNU] License are applicable instead of those
+ * above.  If you wish to allow use of your version of this file only
+ * under the terms of the [GNU] License and not to allow others to use
+ * your version of this file under the MPL, indicate your decision by
+ * deleting  the provisions above and replace  them with the notice and
+ * other provisions required by the [GNU] License.  If you do not delete
+ * the provisions above, a recipient may use your version of this file
+ * under either the MPL or the [GNU] License.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <nano-X.h>
+#include <nxcolors.h>
+
+static int button_down = 0, x = 0, y = 0;
+
+GR_WINDOW_ID init(char *tuxfile)
+{
+	GR_GC_ID gc;
+	GR_IMAGE_ID iid;
+	GR_WINDOW_ID wid;
+	GR_REGION_ID rid;
+	GR_WINDOW_ID pid;
+	GR_IMAGE_INFO iif;
+	GR_WM_PROPERTIES props;
+	GR_SCREEN_INFO sinfo;
+	int x, y;
+
+	if(GrOpen() < 0) {
+		fprintf(stderr, "Couldn't connect to Nano-X server\n");
+		return 0;
+	}
+	GrGetScreenInfo(&sinfo);
+
+	if(!(iid = GrLoadImageFromFile(tuxfile, 0))) {
+		fprintf(stderr, "Failed to load image file \"%s\"\n", tuxfile);
+		return 0;
+	}
+	GrGetImageInfo(iid, &iif);
+	pid = GrNewPixmap(iif.width, iif.height, NULL);
+	gc = GrNewGC();
+	GrDrawImageToFit(pid, gc, 0, 0, iif.width, iif.height, iid);
+	GrDestroyGC(gc);
+	GrFreeImage(iid);
+
+	x = sinfo.cols - iif.width;
+	y = sinfo.rows - iif.height;
+	wid = GrNewWindowEx(GR_WM_PROPS_APPWINDOW|GR_WM_PROPS_NOAUTOMOVE, NULL,
+			    GR_ROOT_WINDOW_ID, x, y, iif.width, iif.height, GR_ARGB(0,0,0,0));
+
+	GrSetBackgroundPixmap(wid, pid, GR_BACKGROUND_TOPLEFT);
+
+
+	props.flags = GR_WM_FLAGS_PROPS;
+	props.props = GR_WM_PROPS_NODECORATE;
+	GrSetWMProperties(wid, &props);
+
+	GrSelectEvents(wid, GR_EVENT_MASK_CLOSE_REQ |
+			GR_EVENT_MASK_MOUSE_POSITION |
+			GR_EVENT_MASK_BUTTON_UP |
+			GR_EVENT_MASK_BUTTON_DOWN);
+
+	GrMapWindow(wid);
+
+	return wid;
+}
+
+void button_event(GR_EVENT_BUTTON *ev)
+{
+	if(ev->type == GR_EVENT_TYPE_BUTTON_DOWN) {
+		if(ev->buttons & GR_BUTTON_R) {
+			GrClose();
+			exit(0);
+		}
+		button_down = 1;
+		x = ev->x;
+		y = ev->y;
+		GrRaiseWindow(ev->wid);
+	} else button_down = 0;
+}
+
+void position_event(GR_EVENT_MOUSE *ev)
+{
+	static int newx = 0, newy = 0, oldx = 0, oldy = 0;
+
+	if(!button_down) return;
+
+	newx = ev->rootx - x;
+	newy = ev->rooty - y;
+
+	if(newx != oldx || newy != oldy) {
+		GrMoveWindow(ev->wid, newx, newy);
+		oldx = newx;
+		oldy = newy;
+	}
+}
+
+int main(int argc, char *argv[])
+{
+	char *tuxfile;
+	GR_EVENT event;
+	GR_WINDOW_ID wid;
+
+	if(argc >= 2) tuxfile = argv[1];
+	else {printf("usage: %s <tuxfile>\n",argv[0]);return 1;}
+
+	if(!(wid = init(tuxfile))) return 1;
+
+	while(1) {
+		GrGetNextEvent(&event);
+		switch(event.type) {
+			case GR_EVENT_TYPE_CLOSE_REQ:
+				return 0;
+				break;
+			case GR_EVENT_TYPE_MOUSE_POSITION:
+				position_event(&event.mouse);
+				break;
+			case GR_EVENT_TYPE_BUTTON_UP:
+			case GR_EVENT_TYPE_BUTTON_DOWN:
+				button_event(&event.button);
+				break;
+			default:
+				break;
+		}
+	}
+
+	return 0;
+}
Binärdateien microwindows-0.91/src/demos/nanox/tux2.gif and microwindows-0.91.g100/src/demos/nanox/tux2.gif sind verschieden.
diff -urN microwindows-0.91/src/drivers/fblin16.c microwindows-0.91.g100/src/drivers/fblin16.c
--- microwindows-0.91/src/drivers/fblin16.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/drivers/fblin16.c	2007-06-07 23:49:13.000000000 +0200
@@ -19,6 +19,13 @@
 #include "device.h"
 #include "fb.h"
 
+/*REM*/extern unsigned char* gr_alpha;  /* current alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_x;         /* current x position of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_y;         /* current y position of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_width;     /* current width of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_height;    /* current height of alpha channel*/
+/*REM*/extern MWCLIPMAP *clipmap ;
+
 #define USE_16BIT_ACCESS 0	/* =1 to force 16 bit display access*/
 
 #if USE_16BIT_ACCESS
@@ -55,6 +62,24 @@
 	assert (y >= 0 && y < psd->yres);
 	assert (c < psd->ncolors);
 
+#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap  && clipmap->dirty)
+	/*REM*/   {
+	/*REM*/	   MWCOORD crcx=x-clipmap->clipregion->left;
+	/*REM*/	   MWCOORD crcy=y-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/    if(!(*crc)) return;
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=x-gr_alpha_x;
+	/*REM*/MWCOORD rely=y-gr_alpha_y;
+	/*REM*/if(gr_alpha && (relx>=0)&&(relx<gr_alpha_width)&&(rely>=0)&&(rely<gr_alpha_height))
+	/*REM*/  {if(!gr_alpha[relx+(rely*gr_alpha_width)]) return;}
+#endif
+
 	DRAWON;
 	if(gr_mode == MWMODE_COPY)
 		addr[x + y * psd->linelen] = c;
@@ -89,8 +114,60 @@
 	assert (y >= 0 && y < psd->yres);
 	assert (c < psd->ncolors);
 
-	DRAWON;
 	addr += x1 + y * psd->linelen;
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty)
+	/*REM*/   {
+	/*REM*/	    MWCOORD crcx=x1-clipmap->clipregion->left;
+	/*REM*/	    MWCOORD crcy=y-clipmap->clipregion->top;
+	/*REM*/     clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/     crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+	
+	/*REM*/ MWCOORD relx1=x1-gr_alpha_x;
+	/*REM*/ MWCOORD rely =y-gr_alpha_y;
+	/*REM*/ unsigned char* alpha=NULL;
+  	/*REM*/  if(gr_alpha && (relx1>=0) && (relx1<gr_alpha_width) && (rely>=0) && (rely<gr_alpha_height) &&
+	/*REM*/     ((x2-x1)<=gr_alpha_width))
+	/*REM*/       alpha=&gr_alpha[relx1+(rely*gr_alpha_width)];
+/*REM*/#endif
+
+	DRAWON;
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/if (gr_mode == MWMODE_COPY) {
+	/*REM*/  if(crc||alpha) {
+ 	/*REM*/      while (x1++ <= x2){
+	/*REM*/	       if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha)) *addr = c;}
+	/*REM*/	       if(crc)crc++;
+	/*REM*/	       if(alpha)alpha++;
+	/*REM*/	       addr++;
+	/*REM*/      }
+	/*REM*/	 } else {
+	/*REM*/	      /* FIXME: memsetw(dst, c, x2-x1+1)*/
+	/*REM*/	      while(x1++ <= x2)
+	/*REM*/	       *addr++ = c;
+	/*REM*/	 }
+	/*REM*/} else if (gr_mode <= MWMODE_SIMPLE_MAX) {
+	/*REM*/  if(crc||alpha) {
+	/*REM*/	     while (x1++ <= x2) {
+	/*REM*/	       if((crc&&(*crc))||(!crc)) 
+	/*REM*/		{if((alpha&&(*alpha))||(!alpha)) applyOp(gr_mode, c, addr, ADDR16);}
+	/*REM*/	       if(crc)crc++;
+	/*REM*/	       if(alpha)alpha++;
+	/*REM*/	       ++addr;
+	/*REM*/      }
+	/*REM*/	 } else {
+	/*REM*/	      /* FIXME: memsetw(dst, c, x2-x1+1)*/
+	/*REM*/	      while(x1++ <= x2)
+	/*REM*/		applyOp(gr_mode, c, addr, ADDR16);
+	/*REM*/	        ++addr;
+	/*REM*/	 }
+	/*REM*/}
+/*REM*/#else
 	if(gr_mode == MWMODE_COPY) {
 		/* FIXME: memsetw(dst, c, x2-x1+1)*/
 		while(x1++ <= x2)
@@ -101,6 +178,7 @@
 			++addr;
 		}
 	}
+/*REM*/#endif
 	DRAWOFF;
 }
 
@@ -118,8 +196,47 @@
 	assert (y2 >= y1);
 	assert (c < psd->ncolors);
 
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap  && clipmap->dirty)
+	/*REM*/   {
+	/*REM*/	    MWCOORD crcx=x-clipmap->clipregion->left;
+	/*REM*/	    MWCOORD crcy=y1-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=x-gr_alpha_x;
+	/*REM*/MWCOORD rely1=y1-gr_alpha_y;
+	/*REM*/MWCOORD rely2=y2-gr_alpha_y;
+	/*REM*/unsigned char* alpha=NULL;
+	/*REM*/if(gr_alpha&& (relx>=0)&&(relx<gr_alpha_width)&&(rely1>=0)&&(rely1+rely2<=gr_alpha_height))
+	/*REM*/     alpha=&gr_alpha[relx+(rely1*gr_alpha_width)];
+/*REM*/#endif
+
 	DRAWON;
 	addr += x + y1 * linelen;
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/if (gr_mode == MWMODE_COPY) {
+	/*REM*/	while (y1++ <= y2) {
+	/*REM*/	        if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha)) *addr = c;}
+	/*REM*/	        if(crc)crc+=clinelen;
+	/*REM*/	        if(alpha)alpha+=gr_alpha_width;
+	/*REM*/		addr += linelen;
+	/*REM*/	}
+	/*REM*/} else if (gr_mode <= MWMODE_SIMPLE_MAX) {
+	/*REM*/	while (y1++ <= y2) {
+	/*REM*/         if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha))applyOp(gr_mode, c, addr, ADDR16);}
+	/*REM*/         if(crc)crc+=clinelen;
+	/*REM*/	        if(alpha)alpha+=gr_alpha_width;
+	/*REM*/		addr += linelen;
+	/*REM*/ }
+	/*REM*/}
+/*REM*/#else
 	if(gr_mode == MWMODE_COPY) {
 		while(y1++ <= y2) {
 			*addr = c;
@@ -131,8 +248,10 @@
 			addr += linelen;
 		}
 	}
+/*REM*/#endif
+	  
 	DRAWOFF;
-}
+ }
 
 /* srccopy bitblt*/
 static void
@@ -144,6 +263,10 @@
 	int	i;
 	int	dlinelen = dstpsd->linelen;
 	int	slinelen = srcpsd->linelen;
+/*REM*/	int clinelen_minus_w;
+/*REM*/	int dlinelen_minus_w;
+/*REM*/	int slinelen_minus_w;
+/*REM*/	int alinelen_minus_w;
 #if ALPHABLEND
 	unsigned int alpha;
 #endif
@@ -162,6 +285,25 @@
 	assert (srcy+h <= srcpsd->yres);
 
 	DRAWON;
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap  && clipmap->dirty)
+	/*REM*/   {
+	/*REM*/	   MWCOORD crcx=dstx-clipmap->clipregion->left;
+	/*REM*/	   MWCOORD crcy=dsty-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=dstx-gr_alpha_x;
+	/*REM*/MWCOORD rely=dsty-gr_alpha_y;
+	/*REM*/unsigned char* alphac=NULL;
+	/*REM*/if(gr_alpha&& (relx>=0)&&(relx+w<=gr_alpha_width)&&(rely>=0)&&(rely+h<=gr_alpha_height))
+	/*REM*/   alphac=&gr_alpha[relx+(rely*gr_alpha_width)];
+/*REM*/#endif
+
 	dst += dstx + dsty * dlinelen;
 	src += srcx + srcy * slinelen;
 
@@ -226,6 +368,29 @@
 			dst += dlinelen;
 			src += slinelen;
 		}
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/	} else if ((op & MWROP_EXTENSION) == MWROP_SRCTRANSCOPY)
+/*REM*/	  {
+/*REM*/	    dlinelen_minus_w = (dlinelen - w);
+/*REM*/	    slinelen_minus_w = (slinelen - w);
+/*REM*/	    clinelen_minus_w = (clinelen - w);
+/*REM*/	    alinelen_minus_w = (gr_alpha_width - w);
+/*REM*/	    while (--h >= 0) {
+/*REM*/	       for (i = 0; i < w; ++i) {
+/*REM*/	        if((crc&&(*crc))||(!crc)) 
+/*REM*/		 {if((alphac&&(*alphac))||(!alphac)) *dst = *src;}
+/*REM*/	         src++;
+/*REM*/	         dst++;
+/*REM*/	         if(crc)crc++;
+/*REM*/	         if(alphac)alphac++;
+/*REM*/        }
+/*REM*/	       dst += dlinelen_minus_w;
+/*REM*/	       src += slinelen_minus_w;
+/*REM*/	       if(crc) crc += clinelen_minus_w;
+/*REM*/	       if(alphac) alphac += alinelen_minus_w;
+/*REM*/     }
+/*REM*/#endif
+
 	} else {
 		while (--h >= 0) {
 			for (i=0; i<w; i++) {
